﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;
using Example3Client.MultiplyService;
using System.Diagnostics;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.ServiceModel.Discovery;

namespace Example3Client
{
    public partial class Form1 : Form
    {
        protected List<CMatrixClient> clients;
        protected Dictionary<string, Stopwatch> watch;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void butConnect_Click(object sender, EventArgs e)
        {
            NetTcpBinding bind = new NetTcpBinding("NetTcpBinding_CMatrix");
            bind.Security.Mode = SecurityMode.None;
            clients = new List<CMatrixClient>();
            for (int i = 0; i < serversListBox.Items.Count; i++)
            {
                if (serversListBox.GetItemCheckState(i) == CheckState.Checked)
                {
                    CMatrixClient clientNew = new CMatrixClient(bind,
                         new EndpointAddress(serversListBox.Items[i].ToString()));
                    clientNew.Open();
                    clients.Add(clientNew);
                }
            }
            butConnect.Enabled = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            watch = new Dictionary<string, Stopwatch>();
            int size = int.Parse(txtSize.Text);
            int min = int.Parse(txtMin.Text);
            int max = int.Parse(txtMax.Text);
            double dSize = 1.0 * size / clients.Count;            
            for (int i = 0; i < clients.Count; i++)
            {
                string uri = clients[i].Endpoint.Address.Uri.ToString();
                watch.Add(uri, new Stopwatch());
                Example3Lib.CMatrixData data = new Example3Lib.CMatrixData();
                CMatrixClient client = clients[i];                
                data.m1 = (float[][])Example3Lib.MySerial.Deserialize(client.Generate(size, min, max));
                data.m2 = (float[][])Example3Lib.MySerial.Deserialize(client.Generate(size, min, max));
                data.begIndex = (int)Math.Round(dSize * i);
                data.endIndex = (int)Math.Round(dSize * (i + 1));
                watch[uri].Reset();
                watch[uri].Start();
                labelTime.Visible = true;
                labelTime.Text = "идет процесс решения...";
                client.BeginMultiple(Example3Lib.MySerial.Serialize(data), delegate(IAsyncResult ar)
                {                    
                    CMatrixClient curClient = (CMatrixClient)ar.AsyncState;
                    string curUri = curClient.Endpoint.Address.Uri.ToString();
                    Stream stream = curClient.EndMultiple(ar);
                    watch[curUri].Stop();
                    if (timersListBox.InvokeRequired)
                    {
                        timersListBox.Invoke(new Action(delegate()
                            {
                                timersListBox.Items.Add(curClient.Endpoint.Address.Uri + "-" + watch[curUri].Elapsed.ToString());
                            }));
                    }
                    else
                        timersListBox.Items.Add(curClient.Endpoint.Address.Uri + "-" + watch[curUri].Elapsed.ToString());
                }, client);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            UdpDiscoveryEndpoint endpoint = new UdpDiscoveryEndpoint();
            DiscoveryClient client = new DiscoveryClient(endpoint);
            FindCriteria criteria = new FindCriteria(typeof(CMatrix));
            criteria.Duration = new TimeSpan(0, 0, 1);
            FindResponse responce = client.Find(criteria);
            serversListBox.Items.Clear();
            for (int i = 0; i < responce.Endpoints.Count; i++)
            {
                serversListBox.Items.Add(responce.Endpoints[i].Address.ToString(), true);
            }
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }
}
