﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.Threading.Tasks;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;

namespace Example3Lib
{
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
    [ServiceContract]
    public class CMatrix
    {        
        [OperationContract]
        Stream Generate(int size, int min, int max)
        {
            Random rnd = new Random();
            float[][] arr = new float[size][];
            for (int i = 0; i < size; i++)
            {
                arr[i] = new float[size];
                for (int j = 0; j < size; j++)
                    arr[i][j] = (float)(rnd.Next(min * 100, (max + 1) * 100) / 100.0);
            }            
            return MySerial.Serialize(arr);
        }
        [OperationContract]
        Stream Multiple(Stream stream)
        {
            BinaryFormatter formatter = new BinaryFormatter();
            CMatrixData data = (CMatrixData)MySerial.Deserialize(stream);            
            float[][] m1 = data.m1;
            float[][] m2 = data.m2;
            int begIndex = data.begIndex;
            int endIndex = data.endIndex;
            int size = m1.GetLength(0);
            float[][] res = new float[size][];
            for (int i = 0; i < size; i++)
                res[i] = new float[size];
            Parallel.For(begIndex, endIndex, delegate(int i)
            {
                for (int j = 0; j < size; j++)
                    for (int k = 0; k < size; k++)
                        res[i][j] += m1[i][k] * m2[k][j];
            });
            return MySerial.Serialize(res);
        }        
   }
    [Serializable, DataContract]
    public struct CMatrixData
    {        
        [DataMember]
        public float[][] m1, m2;
        [DataMember]
        public int begIndex, endIndex;
    }
    public class MySerial
    {
        public static object Deserialize(Stream stream)
        {
            BinaryFormatter formatter = new BinaryFormatter();
            return formatter.Deserialize(stream);
        }
        public static MemoryStream Serialize(object obj)
        {
            MemoryStream ms = new MemoryStream();
            BinaryFormatter formatter = new BinaryFormatter();
            formatter.Serialize(ms, obj);
            ms.Seek(0, SeekOrigin.Begin);
            return ms;
        }
    }
}
