﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.ServiceModel.Discovery;
using Example3Lib;
using System.Net;

namespace Example3Server
{
    public partial class Form1 : Form
    {
        protected ServiceHost sh;
        public Form1()
        {
            InitializeComponent();
        }
        public void StartServer()
        {
            string ip = ipsComboBox.Text;
            
            sh = new ServiceHost(typeof(CMatrix),
                new Uri("net.tcp://" + ip +":9000/Multiply"));
            NetTcpBinding bind = new NetTcpBinding("example3ServerBinding");
            bind.Security.Mode = SecurityMode.None;
            sh.AddServiceEndpoint(typeof(CMatrix), bind, "");
            
            ServiceMetadataBehavior sb = new ServiceMetadataBehavior();
            sh.Description.Behaviors.Add(sb);
            sh.AddServiceEndpoint(typeof(IMetadataExchange),
                  MetadataExchangeBindings.CreateMexTcpBinding(), "mex");

            sh.AddServiceEndpoint(new UdpDiscoveryEndpoint());
            ServiceDiscoveryBehavior sd = new ServiceDiscoveryBehavior();
            sh.Description.Behaviors.Add(sd);


            sh.Open();
            butStart.Enabled = false;
            butStop.Enabled = true;
        }
        public void StopServer()
        {
            sh.Close();
            butStart.Enabled = true;
            butStop.Enabled = false;
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            string name = Dns.GetHostName();
            IPAddress[] ips = Dns.GetHostAddresses(name);
            ipsComboBox.Items.Clear();
            for (int i = 0; i < ips.Length; i++)
                ipsComboBox.Items.Add(ips[i].ToString());
            ipsComboBox.SelectedIndex = 0;
            butStop.Enabled = false;
            StartServer();
        }

        private void butStart_Click(object sender, EventArgs e)
        {
            StartServer();
        }

        private void butStop_Click(object sender, EventArgs e)
        {
            StopServer();
        }
    }
}
